
import java.awt.*;
import java.applet.Applet;
import java.net.*;
import java.io.*;
import java.util.*;


public class Piskvorky extends Applet {
	Point rozmer;
	int[][] hraciePole;
	Papier papier;
	Pocitac pocitac;

	Label vysLab;
	Button vysTlac;

	Button vysEnter;
	TextField vysMeno;
	Label vysPopis;
	Label vysSprava;
	int stav;  // 0..caka sa na stlacenie "Zacni"; 1..hraje sa
	boolean zacinaPocitac;
	Point highlighted = null;

	public void init () {
		String hx = getParameter("RX");
		String hy = getParameter("RY");
		int rx = (hx==null)?20:Integer.valueOf(hx).intValue();
		int ry = (hy==null)?20:Integer.valueOf(hy).intValue();
		rozmer = new Point(rx,ry);
		hraciePole = new int[rozmer.x][];
		for (int i = 0; i<rozmer.x; i++) {
			hraciePole[i] = new int[rozmer.y];
		}
		stav = 0;
		Color bgc = new Color(255,255,200);
		pocitac = new Pocitac(this);
		papier = new Papier(this);
		papier.setBackground(bgc);
		    vysTlac = new Button("Zacni");
			vysLab = new Label("     Piskvorky!    (by semmic 2001)     ");
			vysPopis = new Label("Vitaz:");

			vysEnter = new Button("Vloz");
			vysMeno = new TextField(20);
			vysSprava  = new Label();

		setLayout (new BorderLayout());

		add("Center",papier);
		zacinaPocitac=false;
	}


	void PrijmacPapieru(Point kde) {
		if (stav==0) return;
		if (hraciePole[kde.x][kde.y]!=0) return;
		hraciePole[kde.x][kde.y]=2;
		papier.repaint();
		int r = pocitac.hraj();
		if (r!=0) {
			if (r==1)
				vysLab.setText("Vyhral pocitac!");
			else {
				vysLab.setText("Vyhral clovek!");

			}
			stav = 0;
		}
	}

	void vymazPole() {
		highlighted = null;
		for (int i = 0; i<rozmer.x; i++)
			for (int j = 0; j<rozmer.y; j++) {
				hraciePole[i][j]=0;
			}
		papier.repaint();
	}


	public boolean action(Event evt, Object what) {
		if (evt.arg=="Zacni") {
			vymazPole();
			stav=1;
			if (zacinaPocitac) {
				hraciePole[rozmer.x /2][rozmer.y/2] = 1 + 8;
				highlighted = new Point(rozmer.x / 2 ,rozmer.y / 2);
				papier.repaint();
			}
			vysLab.setText("Hraj!");
			zacinaPocitac = !zacinaPocitac;
		}


		return false;
	}

	public boolean mouseDown(Event evt, int x, int y) {
		x = x/(papier.size().width/rozmer.x);
		y = y/(papier.size().height/rozmer.y);
		if (x>=rozmer.x || y>=rozmer.y)
			return false;
		PrijmacPapieru(new Point(x,y));
		return false;
	}






	}





class Papier extends Canvas {
	Piskvorky piskvorky;
	Point rozmer;
	int[][] hraciePole;

	public Papier(Piskvorky pis) {
		piskvorky = pis;
		rozmer = pis.rozmer;
		hraciePole = pis.hraciePole;
		setBackground( Color.white);
	}

	public void paint(Graphics g) {
		Dimension s = size();
		Dimension cs = new Dimension(s.width / rozmer.x,
							s.height / rozmer.y);
		g.setColor( Color.black );
		for (int i=1; i<rozmer.y; i++) {
			g.drawLine(0, cs.height*i, s.width, cs.height*i);
		}
		for (int i=1; i<rozmer.x; i++) {
			g.drawLine(cs.width*i, 0, cs.width*i, s.height);
		}
		for (int i = 0; i<rozmer.x; i++)
			for (int j = 0; j<rozmer.y; j++) {

				if ((hraciePole[i][j]&4) !=0) {
					g.setColor( Color.black );
					g.fillRect( i*cs.width+1,  j*cs.height+1, cs.width-1, cs.height-1);
				}
				else if ((hraciePole[i][j]&8) !=0) {
					g.setColor( Color.yellow );
					g.fillRect( i*cs.width+1,  j*cs.height+1, cs.width-1, cs.height-1);
				}
				if ((hraciePole[i][j]&3)==2) {
					g.setColor( Color.blue);
					g.drawOval( i*cs.width+2, j*cs.height+2, cs.width-4, cs.height-4);
				}
				else if ((hraciePole[i][j]&3)==1) {
					g.setColor( Color.red);
					g.drawLine( i*cs.width+2, j*cs.height+2, (i+1)*cs.width-2, (j+1)*cs.height-2);
					g.drawLine( i*cs.width+2, (j+1)*cs.height-2, (i+1)*cs.width-2, j*cs.height+2);
				}
			}
	}

}






class Pocitac {
	Piskvorky piskvorky;
	Point rozmer;
	int[][] hraciePole;
	int[][] hodPole;
	int hodnotenie[] = {2,30,100,500,10000,0,  1,20,90,400,8000,0};
	boolean fProhra,fVyhra;
	int maxHod;
	Point pProhra = new Point(0, 0), pVyhra = new Point(0, 0), pMaxHod = new Point(0, 0);
	Point sVyhra = new Point(0, 0), sProhra = new Point(0, 0);

	Pocitac (Piskvorky p) {
		piskvorky = p;
		rozmer = p.rozmer;
		hraciePole = p.hraciePole;
		hodPole = new int[rozmer.x][];
		for (int i = 0; i<rozmer.x; i++) {
			hodPole[i] = new int[rozmer.y];
		}
		for (int i=0; i<12; i++) {
			String h = piskvorky.getParameter("H"+i);
System.out.println("Parameter "+i+"  "+h);
			if (h!=null)
				hodnotenie[i]=Integer.valueOf(h).intValue();
		}
	}

	int hraj() {
		// zrusenie zvyraznenia posledneho tahu
		if (piskvorky.highlighted != null) {
			hraciePole[piskvorky.highlighted.x][piskvorky.highlighted.y] &= ~8;
			piskvorky.highlighted = null;
		}

		for (int i = 0; i<rozmer.x; i++)
			for (int j = 0; j<rozmer.y; j++)
				hodPole[i][j]=0;
		fPrehra = fVyhra = false;
		hodSmer(rozmer.x-4, 0, rozmer.y, 1, 0);
		hodSmer(rozmer.x, 0, rozmer.y-4, 0, 1);
		hodSmer(rozmer.x-4, 0, rozmer.y-4, 1, 1);
		hodSmer(rozmer.x-4, 4, rozmer.y, 1, -1);
		maxHod=0;
		pMaxHod.x=0; pMaxHod.y=0;
		for (int i = 0; i<rozmer.x; i++)
			for (int j = 0; j<rozmer.y; j++)
				if (hodPole[i][j]>maxHod && hraciePole[i][j]==0) {
					maxHod = hodPole[i][j];
					pMaxHod.x = i; pMaxHod.y=j;
				}
		if (fPrehra) {
System.out.println("Prehra");
			int x=pPrehra.x, y=pPrehra.y;
				for (int k = 0; k<5; k++) {
					hraciePole[x][y]=2+4; //potom vyrazna 2
					x+=sPrehra.x; y+=sPrehra.y;
				}
			piskvorky.papier.repaint();
			return 2;

		}
		if (fVyhra) {
System.out.println("Vyhra");
			int x=pVyhra.x, y=pVyhra.y;
				for (int k = 0; k<5; k++) {
					hraciePole[x][y]=1+4; //potom vyrazna 1
					x+=sVyhra.x; y+=sVyhra.y;
				}
			piskvorky.papier.repaint();
			return 1;
		}
System.out.println("Pocitac hraje ("+pMaxHod.x+","+pMaxHod.y+")");
		piskvorky.vysLab.setText("Hrajem ["+pMaxHod.x+","+pMaxHod.y+"]");
		hraciePole[pMaxHod.x][pMaxHod.y]=1;
		// zvyraznenie posledneho tahu
		piskvorky.highlighted = new Point(pMaxHod.x, pMaxHod.y);
		hraciePole[piskvorky.highlighted.x][piskvorky.highlighted.y] |= 8;
		piskvorky.papier.repaint();
		return 0;
	}

	void hodSmer(int bx, int ay, int by, int sx, int sy) {
		for (int i = 0; i<bx; i++)
			for (int j = ay; j<by; j++) {
				int x=i, y=j, kr=0, ko=0;
				for (int k = 0; k<5; k++) {
					if (hraciePole[x][y]==1)
						kr++;
					else if (hraciePole[x][y]==2)
						ko++;
					x+=sx; y+=sy;
				}
				int h=0;
				if (ko==0) {
					h=hodnotenie[kr];
					if (kr==4) {
						fVyhra=true;
						pVyhra.x = i; pVyhra.y = j;
						sVyhra.x = sx; sVyhra.y = sy;
					}
				}
				if (kr==0) {
					h+=hodnotenie[ko+6];
					if (ko==5) {
						fPrehra=true;
						pPrehra.x = i; pPrehra.y = j;
						sPrehra.x = sx; sPrehra.y = sy;
					}
				}
				x=i; y=j;
				for (int k = 0; k<5; k++) {
					hodPole[x][y]+=h;
					x+=sx; y+=sy;
				}
			}
	}
}



