//**********************************************************//
//                  Trieda INI parser
//**********************************************************//

//Riesenie: Robert Novotny 2I2, r.novotny@szm.sk
//december 2001

package novotnyr;

import java.util.Vector;
import novotnyr.*;

public class IniParser {
  public Vector sections;

  public void load(String filename){
    sections.removeAllElements();
    //nacitame zo suboru
    zapocty.util.FileReader f = new zapocty.util.FileReader(filename);
	  if (f.lastError() != null) {
		  System.out.println("Chyba pri otvarani suboru.\n"+f.lastError());
      return;
    }
    String line;
  	while ((line = f.nextLine()) != null) {
      if ( (line.startsWith("[") && (line.endsWith("]")))){
        IniSection ns=new IniSection();//zakladame novu sekciu
        ns.name=line.substring(1,line.length()-1);
        sections.addElement(ns);
      } else {
        IniEntry ne=new IniEntry();
        int epos=line.indexOf("=");//pozicia = v na riadku
        //explodne string na kluc..
        ne.key=line.substring(0,epos);
        //..a hodnotu
        ne.value=line.substring(epos+1);
        //do poslednej pridanej sekcie pridame novu polozku
        ((IniSection) sections.lastElement()).polozky.addElement(ne);
      }
    }
  } //load

  public IniParser() {    //konstruktor
    //najprv zostrojime Vector sekcii
    sections=new Vector();
  }

  public String getProperty(String section, String name, String implicit){
    for (int i=0;i<sections.size();i++){

      IniSection cs=(IniSection) sections.elementAt(i);
      if (  cs.name.equals(section) ) {
        //nasli sme sekciu
        for (int j=0;j<cs.polozky.size();j++){
          IniEntry e=(IniEntry) cs.polozky.elementAt(j);
          if (e.key.equals(name)){
            return e.value;
          }
        }
        return implicit;
      }
    }
    return implicit;
  }//String getProperty

  public int getProperty(String section, String name, int implicit){
    String x=getProperty(section,name,"");
    if (x != ""){
      //odchytenie nespravneho castovania..
      try {
        Integer ix=new Integer(x);
        return ix.intValue();
      } catch (NumberFormatException e){
          return implicit;
      }
    } else
      return implicit;
  }

  public boolean getProperty(String section, String name, boolean implicit){
    String x=getProperty(section,name,null);
    if (x != null){
      //  dalo by sa cez booleanValue, hadze to vsak hluposti...
      if ( (x.toLowerCase()=="true") || (x=="1") )
        return true;
      if ( (x.toLowerCase()=="false") || (x=="0") )
        return false;
    }
    return implicit;
  }
  public void printSections(){
  //prozatim vypise vsetky sekcie...
    for (int i=0;i<sections.size();i++){
      System.out.println( ((IniSection) sections.elementAt(i)).name );    }
  }
}
