//**********************************************************//
//               Testovacia trieda INI parsera
//**********************************************************//

/*3. MyProperties
  - trieda spristupnujuca properties ulozene v textovom subore
  - ignorovat prazdne riadky (tie co obsahuju iba whitespaces (w))
  - ignorovat aj vsetky ostatne riadky,
    co nie su w*[<section>]w* resp. <propname>w*=w*<propvalue>w*
  - minimalne pozadovane API:
    konstruktor()
    load(filename) - nanovo (replace) naplni properties z file-u
    String getProperty(String section, String name, String default) - vrati stringovu property
                  s menom 'name' nachadzajucu sa v sekcii 'section'. ak taka nie je, vrati default hodnotu
    int getProperty(String section, String name, int default)
    boolean getProperty(String section, String name, boolean default)
       - analogicky ako strigova verzia, akurat sa vykona aj automaticka konverzia
         na pozadovany typ. ak property neexistuje, alebo konverzia nie je mozna, vrati default
         pri boolean podporit format true/false aj 1/0
*/
//Riesenie: Robert Novotny 2I2, r.novotny@szm.sk
//december 2001

package novotnyr;

public class testerIniParser {

  public static void main(String[] args) {
    iniParser ip=new iniParser();
    ip.load("d:\\java\\rniniparser\\ini.ini");

 /* rozne priklady i kontrapriklady, v pripade potreby odkomentovat */

    //neexistujuca sekcia, neexistujuca polozka
    System.out.println(ip.getProperty("WinampCfg","MP3Player","Nothing found (1)"));
    //Existujuca polozka
    System.out.println(ip.getProperty("JavaDoc","LoveJava","Nothing found (2)"));
    //Existujuca sekcia, neexistujuca polozka
    System.out.println(ip.getProperty("JavaSvr","Port","Nothing found (3)"));

    System.out.println("*********************");
    //nacitanie booleanu
    if (!ip.getProperty("Sekcia1","ILoveJava",true)){
      System.out.println("IAINTLOVEJAVA");
    }
    //nacitanie integeru
    int r=100*ip.getProperty("Sekcia1","MarkGiven",0);
    System.out.println(r);
    //priklad na nacitanie hodnoty do nespravneho typu (String do int)
    int p=100*ip.getProperty("Alfa11","UserName",0);
    System.out.println(p);

    //priklad na nacitanie hodnoty do nespravneho typu (String do bool)
    if (ip.getProperty("Alfa11","UserName",true)){
      System.out.println("IAINTLOVEJAVA");
    }
  }
}
