
/**
 * 
 * FileReader.java
 * 
 * pomocna trieda pre 
 * nacitanie obsahu suboru		
 *
 */
				
package zapocty.util;

public class FileReader {

	// 
	// konstruktor citaca 
	// nad zadanym suborom
	//
	public FileReader(String filename) {

		try {
			err = null;
			in = new java.io.BufferedReader(new java.io.FileReader(filename));
		} catch (java.io.IOException e) {
      in = null;
      err = e.toString();
    }
  }

  // 
  // nacitanie dalsieho riadku suboru
  // vrati null, ak dojde na EOF
  // 
  public String nextLine() {

		if (in == null)
			return null;

		try {
			return in.readLine();
		} catch (java.io.IOException e) {
      in = null;
      err = e.toString();
			return null;
    }
  }

  // 
  // vypise chybu ktora posledna nastala
  // (napr. pri otvarani suboru, alebo aj
  // pripadne pri citani dalsieho riadku)
  // vrati null, ak k ziadnej chybe nedoslo
  //
  public String lastError() {
    return err;
  }

  private String err;
  private java.io.BufferedReader in;
}
